<?php
class mime_mail
{
	var $parts;
	var $to;
	var $to_name;
	var $from;
	var $from_name;
	var $subject;
	var $send_date;
	var $body;
	function mime_mail()
	{
		$this->parts = array();
		$this->to = '';
		$this->to_name = '';
		$this->from = '';
		$this->from_name = '';
		$this->subject = '';
		$this->send_date = '';
		$this->body = '';
	}
	function attach($message, $name, $ctype = '', $encode = '')
	{
		if(empty($ctype))
		{
			switch(strrchr(basename($name), '.'))
			{ 
				case '.gz': $ctype = 'application/x-gzip'; break;
				case '.tgz': $ctype = 'application/x-gzip'; break;
				case '.zip': $ctype = 'application/zip'; break;
				case '.rar': $ctype = 'application/zip'; break;
				case '.pdf': $ctype = 'application/pdf'; break;        
				case '.png': $ctype = 'image/png'; break;
				case '.gif': $ctype = 'image/gif'; break;
				case '.jpg': $ctype = 'image/jpeg'; break;
				case '.txt': $ctype = 'text/plain'; break;
				case '.htm': $ctype = 'text/html'; break;
				case '.html': $ctype = 'text/html'; break;
				case '.php': $ctype = 'text/plain'; break;
				default: $ctype = 'application/octet-stream'; break;
			}
		}
   		$this->parts[] = array('ctype' => $ctype, 'message' => $message, 'encode' => $encode, 'name' => $name);
	}
	function build_message($part)
	{
		$message = $part['message'];
		$message = chunk_split(base64_encode($message));
		$encoding = 'base64';
		return 'Content-Type: '.$part['ctype'].($part['name'] ? '; name="'.$part['name'].'"' : '').($part['encode'] ? '; charset='.$part['encode'] : '')."\n".
				'Content-Transfer-Encoding: '.$encoding."\n\n".
				$message."\n";
	}
	function build_multipart()
	{
		$boundary = 'b'.md5(uniqid(time()));
		$multipart = 'Content-Type: multipart/mixed; boundary='.$boundary."\n".'This is a MIME encoded message.'."\n".'--'.$boundary;
		for($i = sizeof($this->parts) - 1; $i >= 0; $i--)
		{
			$multipart .= "\n".$this->build_message($this->parts[$i]).'--'.$boundary;
		}
		return $multipart .= '--'."\n";
	}
	function send()
	{
		if(empty($this->to))
		{
			return false;
		}
		if(empty($this->from))
		{
			$this->from = 'inconnu@inconnu.com';
		}
		if(empty($this->from_name))
		{
			$this->from_name = $this->from;
		}
		if(empty($this->to_name))
		{
			$this->to_name = $this->to;
		}
		if(empty($this->send_date))
		{
			$this->send_date = date('r');
		}
		if(!empty($this->body))
		{
			$this->attach($this->body, '', 'text/plain', 'utf-8');
		}
		$mime = 'MIME-Version: 1.0'."\n".
				'Date: '.$this->send_date."\n".
				'From: "'.$this->from_name.'" <'.$this->from.'>'."\n".
				//'To: "'.$this->to_name.'" <'.$this->to.'>'."\n".
				$this->build_multipart();
		return mail($this->to, $this->subject, $this->body, $mime);
	}
};
?>