<?php
#########################################################
#
#             Contact plugin for Dotclear
#             by k-net (www.k-netweb.net)
#
#          if you want to use this plugin to
#        make another one, please contact me ;)
#
#########################################################

$errors = array();

include(dirname(__FILE__).'/install-functions.php');
include(dirname(__FILE__).'/cfg_recipients.php');

buffer::str('<h2>Contact</h2>'."\n");

if (isset($_POST['desinstall'])) {
	$errors[] = Contact::desinstallPlugin();
} else if (isset($_POST['install'])) {
	if (!Contact::isInstalled()) {
		$errors[] = Contact::installPlugin();
	} else {
		$errors[] = array(0, __('Error 101: Plugin already installed.'));
	}
} else if (isset($_POST['changesendmode'])) {
	if (isset($_POST['recipientform_sendmode'])) {
		$recipientConfig['sendto'] = $_POST['recipientform_sendmode'];
	}
	$errors[] = Contact::updateRecipients($recipientConfig);
} else if (isset($_POST['changerecipients'])) {
	if (!empty($_POST['action']) && $_POST['action'] == 'add') {
		if (!empty($_POST['newname']) && !empty($_POST['newemail'])) {
			if (ereg('([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)*@([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)*\.([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)*', $_POST['newemail'])) {
				$recipientConfig['recipients'][] = array('name' => $_POST['newname'], 'email' => $_POST['newemail']);
			} else {
				$errors[] = array(0, __('Error 302: Invalid email.'));
			}
		}
	} else if (!empty($_POST['action']) && $_POST['action'] == 'delete') {
		if (isset($_POST['recipientid'])) {
			unset($recipientConfig['recipients'][$_POST['recipientid']]);
			$recipientConfig['recipients'] = array_values($recipientConfig['recipients']);
		}
	} else if (!empty($_POST['action']) && $_POST['action'] == 'edit') {
		if (isset($_POST['recipientid']) && !empty($_POST['newname']) && !empty($_POST['newemail'])) {
			if (ereg('([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)*@([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)*\.([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)([A-Za-z0-9]|-|_|\.)*', $_POST['newemail'])) {
				$recipientConfig['recipients'][$_POST['recipientid']] = array('name' => $_POST['newname'], 'email' => $_POST['newemail']);
			} else {
				$errors[] = array(0, __('Error 302: Invalid email.'));
			}
		}
	}
	$errors[] = Contact::updateRecipients($recipientConfig);
} else if (isset($_POST['updateform'])) {
	$errors[] = Contact::updateform();
}

// Chargement des variables dans config.ini
$formconfig = array();
$array_tmp = file(dirname(__FILE__).'/config.ini');
foreach ($array_tmp as $v) {
	if ((substr(trim($v), 0, 1) != ';') && (substr_count($v, '=') >= 1)) { // La ligne ne doit pas commencer par un ';' et doit contenir au moins un signe '='
		$pos = strpos($v, '=');
		$formconfig[trim(substr($v, 0, $pos))] = trim(substr($v, $pos+1));
	}
}
unset($array_tmp);

if (!empty($errors)) {
	buffer::str('<p style="font-weight: bold;">'."\n");
	foreach ($errors as $v) {
		buffer::str('<span style="color: #'.($v[0] == 1 ? '0000CC;"><img src="images/check_on.png" alt="Ok"' : 'CC0000;"><img src="images/check_off.png" alt="X"').' width="12" height="12" style="vertical-align: middle;" /> &nbsp;'.__($v[1]).'</span><br />'."\n");
	}
	buffer::str('</p>'."\n");
}

buffer::str(
	'<p style="overflow: hidden;">'."\n".
	'<a href="http://www.k-netweb.net/blog/index.php?2006/03/05/51-plugin-dotclear-contact"><img src="tools/'.Contact::pluginDir().'/icon_100px.png" alt="Contact" width="100" height="66" style="float: left; border: 0; margin: 0 10px;" /></a><br />'."\n".
	'<strong>'.__('Contact is a plugin to create and set really easily a page by which people can contact you by email (with a form).').'</strong>'."\n".
	'</p>'."\n");

buffer::str(
	'<fieldset class="clear"><legend>'.__('Installation').'</legend>'."\n".
	'<form action="tools.php?p='.Contact::pluginDir().'" method="post">'."\n".
	'<p>'."\n".
	__('The plugin is currently').' <strong>'.__(Contact::isInstalled() ? 'installed' : 'not installed').'</strong>. &nbsp; '.
	'<input type="submit" '.(Contact::isInstalled() ? 'name="desinstall" value="'.__('Auto desinstall').'"' : 'name="install" value="'.__('Auto install').'"').' /> &nbsp; '."\n".
	(Contact::isInstalled() ? __('How to desinstall it manually') : __('How to install it manually')).' : '.helpLink('install&amp;plugin='.Contact::pluginDir(), (Contact::isInstalled() ? 'desinstall' : 'install')).'</p></form>'."\n");

if (Contact::isInstalled()) {
	buffer::str('<p>'."\n".
	__('Your contact page is available').' <a href="'.dc_blog_url.'?contact">'.__('here').'</a>. '.__('To make it usable by your visitors, edit code in').' <ins>themes/default/template.php</ins> '.__('and put a link with that code').' :'."\n".
	'</p>'."\n".
	'<pre style="overflow: auto; width: 98%; padding: 5px; border: 1px solid #ccc;">'."\n".
	'&lt;a href="&lt;?php dcInfo(\'url\'); ?&gt;'.(dc_url_scan == 'query_string' ? '?' : '').'contact"&gt;Contact&lt;/a&gt;'."\n".
	'</pre>'."\n");
}
buffer::str('</fieldset>'."\n");

buffer::str(
	'<fieldset class="clear"><legend>'.__('Recipients').'</legend>'."\n".
	'<form id="recipientform" action="tools.php?p='.Contact::pluginDir().'" method="post">'."\n".
	'<p>'."\n".
	'<input type="hidden" name="changerecipients" value="true" />'."\n".
	'<input type="hidden" name="action" value="" />'."\n".
	'<input type="hidden" name="recipientid" value="" />'."\n".
	'<input type="hidden" name="newname" value="" />'."\n".
	'<input type="hidden" name="newemail" value="" />'."\n".
	__('Define here who is/are going to be the email recipient(s).')."\n".
	'</p>'."\n".
	'<p'.(count($recipientConfig['recipients']) < 2 ? ' style="color: #999999;"' : '').'>'."\n".
	'<label for="recipientform_sendmode_all"><input type="radio" id="recipientform_sendmode_all" name="recipientform_sendmode" value="all"'.($recipientConfig['sendto'] == 'all' ? ' checked="checked"' : '').(count($recipientConfig['recipients']) < 2 ? ' disabled="disabled"' : '').' /> '.__('Send the email to all recipients from the list below.').'</label>'."\n".
	'<label for="recipientform_sendmode_select"><input type="radio" id="recipientform_sendmode_select" name="recipientform_sendmode" value="select"'.($recipientConfig['sendto'] == 'select' ? ' checked="checked"' : '').(count($recipientConfig['recipients']) < 2 ? ' disabled="disabled"' : '').' /> '.__('Let the visitor choose who he or she wants to send the email to (from the list below).').'</label>'."\n".
	'</p>'."\n".
	'<script type="text/javascript">'."\n".
	'<!--'."\n".
	'function recipientform_add() {'."\n".
	'	var newname = prompt(\''.__('Name :').'\', \'\');'."\n".
	'	if (newname != \'\') {'."\n".
	'		var newemail = prompt(\''.__('Email :').'\', \'\');'."\n".
	'		if (newemail != \'\') {'."\n".
	'			document.getElementById(\'recipientform\').action.value = \'add\';'."\n".
	'			document.getElementById(\'recipientform\').newname.value = newname;'."\n".
	'			document.getElementById(\'recipientform\').newemail.value = newemail;'."\n".
	'			document.getElementById(\'recipientform\').submit();'."\n".
	'		}'."\n".
	'	}'."\n".
	'}'."\n".
	'function recipientform_delete(recipientid) {'."\n".
	'	if (confirm(\''.__('Are you sure you want to delete this recipient ?').' \')) {'."\n".
	'			document.getElementById(\'recipientform\').action.value = \'delete\';'."\n".
	'		document.getElementById(\'recipientform\').recipientid.value = recipientid;'."\n".
	'		document.getElementById(\'recipientform\').submit();'."\n".
	'	}'."\n".
	'}'."\n".
	'function recipientform_edit(recipientid, recipientname, recipientemail) {'."\n".
	'	var newname = prompt(\''.__('Name :').'\', recipientname);'."\n".
	'	if (newname != \'\') {'."\n".
	'		var newemail = prompt(\''.__('Email :').'\', recipientemail);'."\n".
	'		if (newemail != \'\') {'."\n".
	'			document.getElementById(\'recipientform\').action.value = \'edit\';'."\n".
	'			document.getElementById(\'recipientform\').recipientid.value = recipientid;'."\n".
	'			document.getElementById(\'recipientform\').newname.value = newname;'."\n".
	'			document.getElementById(\'recipientform\').newemail.value = newemail;'."\n".
	'			document.getElementById(\'recipientform\').submit();'."\n".
	'		}'."\n".
	'	}'."\n".
	'}'."\n".
	'//-->'."\n".
	'</script>'."\n".
	'<p style="margin-left: 30px;">'."\n");
if (!empty($recipientConfig['recipients'])) {
	$count = count($recipientConfig['recipients']);
	for ($i = 0; $i < $count; $i++) {
		buffer::str(
			'<span style="font-weight: bold;">'.$recipientConfig['recipients'][$i]['name'].'</span> &nbsp; <span style="color: #666666;">&lt;'.$recipientConfig['recipients'][$i]['email'].'&gt;</span> &nbsp; &nbsp; '.
			'<a href="#" onclick="javascript:recipientform_edit('.$i.', \''.str_replace('\'', '\\\'', $recipientConfig['recipients'][$i]['name']).'\', \''.$recipientConfig['recipients'][$i]['email'].'\'); return(false);">'.__('edit').'</a> <a href="#" onclick="javascript:recipientform_delete('.$i.'); return(false);">'.__('delete').'</a><br />'."\n");
	}
} else {
	buffer::str(
		'<span style="font-style: italic; color: #666666;">'.__('There is no recipient yet.').'</span>'."\n");
}
buffer::str(
	'<br /><a href="#" onclick="javascript:recipientform_add(); return(false);">'.__('Add a recipient').'</a>'."\n".
	'</p>'."\n".
	(count($recipientConfig['recipients']) >= 2 ?
	'<p>'."\n".
	'<input type="submit" name="changesendmode" value="'.__('Update').' !"'.' />'."\n".
	'</p>'."\n" : '').
	'</form>'."\n".
	'</fieldset>'."\n");


buffer::str(
	'<fieldset class="clear"><legend>'.__('Settings for the contact form').'</legend>'."\n".
	'<form action="tools.php?p='.Contact::pluginDir().'" method="post">'."\n".
	'<p>'."\n".
	'<strong>'.__('Set here the captions you want to be on your contact page').' :</strong><br />'."\n".
	'('.__('You can use HTML code').')<br />'."\n".
	__('You can also check or uncheck options you want to be on the page.').'<br />'."\n".
	'<a href="tools/'.Contact::pluginDir().'/preview.php" onclick="javascript:window.open(this.href, \''.__('Preview').'\',\'toolbar=0, location=0, directories=0, status=0, scrollbars=1, resizable=0, copyhistory=0, menuBar=0, width=600, height=400, left=50, top=50\'); return(false);">'.__('You can see the preview of the page by clicking here.').'</a><br />'."\n".
	'</p>'."\n".
	'<p><label for="uf_title_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_title_enabled" name="uf_title_enabled"'.(!empty($formconfig['title_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Form title')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_title_text" value="'.(!empty($formconfig['title_text']) ? $formconfig['title_text'] : '').'" />'."\n".
	'</div>'."\n".
	'<p><label for="uf_info_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_info_enabled" name="uf_info_enabled"'.(!empty($formconfig['info_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Information text')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<textarea cols="30" rows="5" name="uf_info_text">'.(!empty($formconfig['info_text']) ? str_replace('&lt;br /&gt;', "\n", htmlspecialchars($formconfig['info_text'])) : '').'</textarea>'."\n".
	'</div>'."\n".
	'<p><label style="float: left; width: 340px;">'."\n".
	'	&nbsp; &nbsp;'."\n".
	'	'.__('Caption for eventual errors')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" id="uf_errors_text" name="uf_errors_text" value="'.(!empty($formconfig['errors_text']) ? $formconfig['errors_text'] : '').'" />'."\n".
	'</div>'."\n".
	'<p><label for="uf_name_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_name_enabled" name="uf_name_enabled"'.(!empty($formconfig['name_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Caption for the visitor\'s name')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_name_text" value="'.(!empty($formconfig['name_text']) ? $formconfig['name_text'] : '').'" />'."\n".
	'	<input type="checkbox" id="uf_name_required" name="uf_name_required"'.(!empty($formconfig['name_required']) ? ' checked="checked"' : '').' /> <label for="uf_name_required" style="display: inline;">('.__('required').')</label>'."\n".
	'</div>'."\n".
	'<p><label for="uf_email_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_email_enabled" name="uf_email_enabled"'.(!empty($formconfig['email_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Caption for the visitor\'s email')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_email_text" value="'.(!empty($formconfig['email_text']) ? $formconfig['email_text'] : '').'" />'."\n".
	'	<input type="checkbox" id="uf_email_required" name="uf_email_required"'.(!empty($formconfig['email_required']) ? ' checked="checked"' : '').' /> <label for="uf_email_required" style="display: inline;">('.__('required').')</label>'."\n".
	'</div>'."\n".
	'<p><label for="uf_subject_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_subject_enabled" name="uf_subject_enabled"'.(!empty($formconfig['subject_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Caption for the subject')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_subject_text" value="'.(!empty($formconfig['subject_text']) ? $formconfig['subject_text'] : '').'" />'."\n".
	'	<input type="checkbox" id="uf_subject_required" name="uf_subject_required"'.(!empty($formconfig['subject_required']) ? ' checked="checked"' : '').' /> <label for="uf_subject_required" style="display: inline;">('.__('required').')</label>'."\n".
	'</div>'."\n".
	'<p><label for="uf_website_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_website_enabled" name="uf_website_enabled"'.(!empty($formconfig['website_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Caption for the visitor\'s website')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_website_text" value="'.(!empty($formconfig['website_text']) ? $formconfig['website_text'] : '').'" />'."\n".
	'	<input type="checkbox" id="uf_website_required" name="uf_website_required"'.(!empty($formconfig['website_required']) ? ' checked="checked"' : '').' /> <label for="uf_website_required" style="display: inline;">('.__('required').')</label>'."\n".
	'</div>'."\n".
	'<p><label for="uf_body_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_body_enabled" name="uf_body_enabled"'.(!empty($formconfig['body_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Caption for the message')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_body_text" value="'.(!empty($formconfig['body_text']) ? $formconfig['body_text'] : '').'" />'."\n".
	'	<input type="checkbox" id="uf_body_required" name="uf_body_required"'.(!empty($formconfig['body_required']) ? ' checked="checked"' : '').' /> <label for="uf_body_required" style="display: inline;">('.__('required').')</label>'."\n".
	'</div>'."\n".
	'<p><label for="uf_file_enabled" style="float: left; width: 340px;">'."\n".
	'	<input type="checkbox" id="uf_file_enabled" name="uf_file_enabled"'.(!empty($formconfig['file_enabled']) ? ' checked="checked"' : '').' />'."\n".
	'	'.__('Caption for the attached file')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_file_text" value="'.(!empty($formconfig['file_text']) ? $formconfig['file_text'] : '').'" />'."\n".
	'</div>'."\n".
	'<p><label style="float: left; width: 340px;">'."\n".
	'	&nbsp; &nbsp;'."\n".
	'	'.__('Caption on the send button')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="text" name="uf_send_text" value="'.(!empty($formconfig['send_text']) ? $formconfig['send_text'] : '').'" />'."\n".
	'</div>'."\n".
	'<p><label style="float: left; width: 340px;">'."\n".
	'	&nbsp; &nbsp;'."\n".
	'	'.__('Thanks text after email is sent')."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<textarea cols="30" rows="5" name="uf_thanks_text">'.(!empty($formconfig['thanks_text']) ? str_replace('&lt;br /&gt;', "\n", htmlspecialchars($formconfig['thanks_text'])) : '').'</textarea>'."\n".
	'</div>'."\n".
	'<p><label style="float: left; width: 340px;">'."\n".
	'	&nbsp;'."\n".
	'</label></p>'."\n".
	'<div>'."\n".
	'	<input type="submit" name="updateform" value="'.__('Update').' !" />'."\n".
	'</div>'."\n".
	'<p><strong>'.__('Tip to know').' :</strong> '.__('You can also edit the file').' <ins>ecrire/tools/'.Contact::pluginDir().'/form.php</ins> '.__('to add more options.').'</p>'."\n".
	'</form>'."\n".
	'</fieldset>'."\n".
	'<p style="text-align: center;"><a href="http://www.k-netweb.net/blog/index.php?2006/03/05/51-plugin-dotclear-contact">Plugin &copy; k-net</a></p>');
?>