<?php
class Contact {
	function pluginDir() {
		if (is_dir(dirname(__FILE__).'/../Contact')) {
			return 'Contact';
		} else if (is_dir(dirname(__FILE__).'/../contact')) {
			return 'contact';
		} else {
			return false;
		}
	}

	function isInstalled() {
		if (file_exists(dirname(__FILE__).'/../../../layout/lib.mod.php.'.Contact::pluginDir().'.bak') && file_exists(dirname(__FILE__).'/../../../themes/default/template.php.'.Contact::pluginDir().'.bak')) {
			return true;
		} else {
			return false;
		}
	}

	function updateRecipients($recipientConfig) {
		if ($fp = @fopen(dirname(__FILE__).'/cfg_recipients.php', 'w')) {
			$fcontent = '<?php'."\n".
				'$recipientConfig = array();'."\n".
				'$recipientConfig[\'sendto\'] = \''.$recipientConfig['sendto'].'\';'."\n".
				'$recipientConfig[\'recipients\'] = array();'."\n";
			foreach ($recipientConfig['recipients'] as $v) {
				$fcontent .= '$recipientConfig[\'recipients\'][] = array(\'name\' => \''.str_replace('\'', '\\\'', $v['name']).'\', \'email\' => \''.$v['email'].'\');'."\n";
			}
			$fcontent .= '?>';
			fputs($fp, $fcontent);
			fclose($fp);
			return array(1, __('Recipient config file updated successfully.'));
		} else {
			return array(0, __('Error 304: An error occured while writing the file.').' <ins>cfg_recipients.php</ins>');
		}
	}

	function desinstallPlugin() {
		$lib_mod_php = dirname(__FILE__).'/../../../layout/lib.mod.php';
		$template_php = dirname(__FILE__).'/../../../themes/default/template.php';
		if (file_exists($lib_mod_php.'.'.Contact::pluginDir().'.bak') && file_exists($template_php.'.'.Contact::pluginDir().'.bak')) {
			if (copy($lib_mod_php.'.'.Contact::pluginDir().'.bak', $lib_mod_php)) {
				if (unlink($lib_mod_php.'.'.Contact::pluginDir().'.bak')) {
					if (copy($template_php.'.'.Contact::pluginDir().'.bak', $template_php)) {
						if (unlink($template_php.'.'.Contact::pluginDir().'.bak')) {
							// Success !
							return array(1, __('Plugin desinstalled successfully.'));
						} else {
							return array(0, __('Error 204: Plugin desinstallation failed. Try to desinstall it manually. (Cannot delete').' <ins>themes/default/template.php.'.Contact::pluginDir().'.bak</ins>).');
						}
					} else {
						return array(0, __('Error 203: Plugin desinstallation failed. Try to desinstall it manually. (Cannot copy').' <ins>themes/default/template.php.'.Contact::pluginDir().'.bak</ins> '.__('to').' <ins>themes/default/template.php</ins>).');
					}
				} else {
					return array(0, __('Error 204: Plugin desinstallation failed. Try to desinstall it manually. (Cannot delete').' <ins>themes/default/lib.mod.php.'.Contact::pluginDir().'.bak</ins>).');
				}
			} else {
				return array(0, __('Error 203: Plugin desinstallation failed. Try to desinstall it manually. (Cannot copy').' <ins>layout/lib.mod.php.'.Contact::pluginDir().'.bak</ins> '.__('to').' <ins>layout/lib.mod.php</ins>).');
			}
		} else {
			if (file_exists($template_php.'.'.Contact::pluginDir().'.bak')) {
				return array(0, __('Error 201: Plugin desinstallation failed. Try to desinstall it manually. (Missing backup file').' <ins>layout/lib.mod.php.'.Contact::pluginDir().'.bak</ins>).');
			} else if (file_exists($lib_mod_php.'.'.Contact::pluginDir().'.bak')) {
				return array(0, __('Error 201: Plugin desinstallation failed. Try to desinstall it manually. (Missing backup file').' <ins>themes/default/template.php.'.Contact::pluginDir().'.bak</ins>).');
			} else {
				return array(0, __('Error 202: Plugin desinstallation failed. Try to desinstall it manually. (Missing backup files').' <ins>themes/default/template.php.'.Contact::pluginDir().'.bak</ins> '.__('and').' <ins>layout/lib.mod.php.'.Contact::pluginDir().'.bak</ins>).');
			}
		}
	}

	function installPlugin() {
		$lib_mod_php = dirname(__FILE__).'/../../../layout/lib.mod.php';
		$template_php = dirname(__FILE__).'/../../../themes/default/template.php';
		if (file_exists($lib_mod_php) && file_exists($template_php)) {
			if (!copy($lib_mod_php, $lib_mod_php.'.temp.bak')) {
				return array(0, __('Error 111: Plugin installation failed. Try to install it manually. (Cannot copy').' <ins>layout/lib.mod.php</ins> '.__('to').' <ins>layout/lib.mod.php.temp.bak</ins>).');
			} if (!copy($template_php, $template_php.'.temp.bak')) {
				return array(0, __('Error 112: Plugin installation failed. Try to install it manually. (Cannot copy').' <ins>layout/lib.mod.php</ins> '.__('to').' <ins>layout/lib.mod.php.temp.bak</ins>).');
			} if ($lib_mod_php_content = file_get_contents($lib_mod_php)) {
				$oldstr = '	if (!empty($_GET[\'p\'])) {'."\n".
						'		return \'post\';'."\n".
						'	} elseif (!empty($_GET[\'d\']) && strlen($_GET[\'d\']) == 10) {'."\n".
						'		return \'day\';'."\n".
						'	} elseif (!empty($_GET[\'d\']) && strlen($_GET[\'d\']) == 7) {'."\n".
						'		return \'month\';'."\n".
						'	} elseif (!empty($_GET[\'cat\'])) {'."\n".
						'		return \'cat\';'."\n".
						'	} else {'."\n".
						'		return \'home\';'."\n".
						'	}';
				$newstr = '	if (!empty($_GET[\'p\'])) {'."\n".
						'		return \'post\';'."\n".
						'	} elseif (!empty($_GET[\'d\']) && strlen($_GET[\'d\']) == 10) {'."\n".
						'		return \'day\';'."\n".
						'	} elseif (!empty($_GET[\'d\']) && strlen($_GET[\'d\']) == 7) {'."\n".
						'		return \'month\';'."\n".
						'	} elseif (!empty($_GET[\'cat\'])) {'."\n".
						'		return \'cat\';'."\n".
						'	/* Code added by '.Contact::pluginDir().' plugin auto installation */'."\n".
						'	} elseif ((dc_url_scan == \'path_info\' && $GLOBALS[\'dc_args\'] == \'contact\') || (!empty($_SERVER[\'QUERY_STRING\']) && $_SERVER[\'QUERY_STRING\'] == \'contact\')) {'."\n".
						'		return \'contact\';'."\n".
						'	/* End of the added code */'."\n".
						'	} else {'."\n".
						'		return \'home\';'."\n".
						'	}';
				$lib_mod_php_content = str_replace($oldstr, $newstr, $lib_mod_php_content);
				if (!strpos($lib_mod_php_content, $newstr)) {
					copy($lib_mod_php.'.temp.bak', $lib_mod_php);
					unlink($lib_mod_php.'.temp.bak');
					return array(0, __('Error 113: File code different as expected in').' <ins>layout/lib.mod.php</ins>.');
				}
				$fp = fopen($lib_mod_php, 'w');
				if (!fputs($fp, $lib_mod_php_content)) {
					fclose($fp);
					copy($lib_mod_php.'.temp.bak', $lib_mod_php);
					unlink($lib_mod_php.'.temp.bak');
					return array(0, __('Error 114: An error occured while writing the file.').' (<ins>layout/lib.mod.php</ins>)');
				}
				fclose($fp);
				// 1er fichier ok, passons au 2ème 
				if ($template_php_content = file_get_contents($template_php)) {
					$oldstr = '		<h3>Changer le commentaire</h3>'."\n".
							'		<?php include dirname(__FILE__).\'/form.php\'; ?>'."\n".
							'		'."\n".
							'	<?php elseif ($mode != \'post\') : /* Si aucune erreur et mode != post on affiche une liste de billets */?>'."\n".
							'		<?php # Phrase affich� en cas de recherche (%s est le mot cherch�)'."\n".
							'		dcSearchString(\'<p>R&eacute;sultats de votre recherche de <em>%s</em>.</p>\');'."\n".
							'		?>';
					$newstr = '		<h3>Changer le commentaire</h3>'."\n".
							'		<?php include dirname(__FILE__).\'/form.php\'; ?>'."\n".
							'		'."\n".
							'	<?php /* Code added by '.Contact::pluginDir().' plugin auto installation */'."\n".
							'		elseif ($mode == \'contact\') : /* Si le mode est \'contact\' affichage du formulaire */'."\n".
							'			include dirname(__FILE__).\'/../../ecrire/tools/'.Contact::pluginDir().'/contact.php\';'."\n".
							'			/* End of the added code */ ?>'."\n".
							'		'."\n".
							'	<?php elseif ($mode != \'post\') : /* Si aucune erreur et mode != post on affiche une liste de billets */?>'."\n".
							'		<?php # Phrase affich� en cas de recherche (%s est le mot cherch�)'."\n".
							'		dcSearchString(\'<p>R&eacute;sultats de votre recherche de <em>%s</em>.</p>\');'."\n".
							'		?>';
					$template_php_content = str_replace($oldstr, $newstr, $template_php_content);
					if (!strpos($template_php_content, $newstr)) {
						copy($lib_mod_php.'.temp.bak', $lib_mod_php);
						unlink($lib_mod_php.'.temp.bak');
						copy($template_php.'.temp.bak', $template_php);
						unlink($template_php.'.temp.bak');
						return array(0, __('Error 113: File code different as expected in').' <ins>themes/default/template.php</ins>.');
					}
					$fp = fopen($template_php, 'w');
					if (!fputs($fp, $template_php_content)) {
						fclose($fp);
						copy($lib_mod_php.'.temp.bak', $lib_mod_php);
						unlink($lib_mod_php.'.temp.bak');
						copy($template_php.'.temp.bak', $template_php);
						unlink($template_php.'.temp.bak');
						return array(0, __('Error 114: An error occured while writing the file.').' (<ins>themes/default/template.php</ins>)');
					}
					fclose($fp);
					// Success !
					copy($lib_mod_php.'.temp.bak', $lib_mod_php.'.'.Contact::pluginDir().'.bak');
					unlink($lib_mod_php.'.temp.bak');
					copy($template_php.'.temp.bak', $template_php.'.'.Contact::pluginDir().'.bak');
					unlink($template_php.'.temp.bak');
					return array(1, __('Plugin installed successfully.'));
				} else {
					return array(0, __('Error 115: Cannot open').' <ins>themes/default/template.php</ins>.');
				}
			} else {
				return array(0, __('Error 115: Cannot open').' <ins>layout/lib.mod.php</ins>.');
			}
		} else {
			if (file_exists($template_php)) {
				return array(0, __('Error 116: Plugin installation failed. Try to install it manually. (Cannot find').' <ins>layout/lib.mod.php</ins>).');
			} else if (file_exists($lib_mod_php)) {
				return array(0, __('Error 116: Plugin installation failed. Try to install it manually. (Cannot find').' <ins>themes/default/template.php</ins>).');
			} else {
				return array(0, __('Error 116: Plugin installation failed. Try to install it manually. (Cannot find').' <ins>themes/default/template.php</ins> '.__('nor').' <ins>layout/lib.mod.php</ins>).');
			}
		}
	}

	function clearPart($src, $tag, $todo) {
		ereg("__START-".$tag."__(.*)__END-".$tag."__", $src, $str);
		if ($todo == 'all') {
			return str_replace("__START-".$tag."__".$str[1]."__END-".$tag."__", '', $src);
		} else {
			return str_replace("__START-".$tag."__", '', str_replace("__END-".$tag."__", '', $src));
		}
	}
	function updateform() {
		$_POST['uf_info_text'] = str_replace("\n", '<br />', $_POST['uf_info_text']);
		$_POST['uf_thanks_text'] = str_replace("\n", '<br />', $_POST['uf_thanks_text']);
		if (!is_file(dirname(__FILE__).'/form.php.model')) {
			return array(0, __('Error 101: The file <ins>form.php.model</ins> needed by the plugin doesn\'t exists.'));
		}
		$form_php_content = file_get_contents(dirname(__FILE__).'/form.php.model');
		
		$partstoclear = array('uf_title_enabled', 'uf_info_enabled', 'uf_name_enabled', 'uf_email_enabled', 'uf_website_enabled', 'uf_subject_enabled', 'uf_body_enabled', 'uf_file_enabled');
		$partstocleartags = array('TITLE', 'INFO', 'NAME', 'EMAIL', 'WEBSITE', 'SUBJECT', 'BODY', 'FILE');
		for ($i = 0; $i < count($partstoclear); $i++) {
			$form_php_content = Contact::clearPart($form_php_content, $partstocleartags[$i], (empty($_POST[$partstoclear[$i]]) ? 'all' : 'tags'));
		}

		$partstochange = array('uf_title_text', 'uf_info_text', 'uf_errors_text', 'uf_name_text', 'uf_email_text', 'uf_website_text', 'uf_subject_text', 'uf_body_text', 'uf_file_text', 'uf_send_text');
		$partstochangetags = array('TITLE_TEXT', 'INFO_TEXT', 'ERRORS_TEXT', 'NAME_TEXT', 'EMAIL_TEXT', 'WEBSITE_TEXT', 'SUBJECT_TEXT', 'BODY_TEXT', 'FILE_TEXT', 'SEND_TEXT');
		for ($i = 0; $i < count($partstochange); $i++) {
			$form_php_content = str_replace('{'.$partstochangetags[$i].'}', $_POST[$partstochange[$i]], $form_php_content);
		}
		$form_php_content = str_replace('{TITLE_LINK}', dc_blog_url.'?contact', $form_php_content);
		$form_php_content = str_replace('{FORM_LINK}', dc_blog_url.'?contact', $form_php_content);

		$fp = fopen(dirname(__FILE__).'/form.php', 'w');
		if (!fputs($fp, $form_php_content)) {
			return array(0, __('Error 401: An error occured while writing the file.').' (form.php)');
		}
		fclose($fp);
		
		$inivars = array('title_enabled', 'title_text',
						'info_enabled', 'info_text',
						'errors_text',
						'name_enabled', 'name_required', 'name_text',
						'email_enabled', 'email_required', 'email_text',
						'subject_enabled', 'subject_required', 'subject_text',
						'website_enabled', 'website_required', 'website_text',
						'body_enabled', 'body_required', 'body_text',
						'file_enabled', 'file_required', 'file_text',
						'send_text',
						'thanks_text');
		$config_ini_content = '';
		for ($i = 0; $i < count($inivars); $i++) {
			$config_ini_content .= (empty($_POST['uf_'.$inivars[$i]]) ? '' : $inivars[$i].'='.$_POST['uf_'.$inivars[$i]]."\n");
		}
		$fp = fopen(dirname(__FILE__).'/config.ini', 'w');
		if (!fputs($fp, $config_ini_content)) {
			return array(0, __('Error 402: An error occured while writing the file.').' (config.ini)');
		}
		fclose($fp);
		
		return array(1, __('Update completed successfully.'));
	}
}
?>